
/*
 * Copyright (C) 2016 lovdream.com
 *
 */

package com.lovdream;

import android.os.IBinder;
import android.os.RemoteException;
import android.util.Log;

import com.unistrong.pogoservicelib.BuildConfig;

import java.lang.reflect.Method;

public class LovUtil {
	private static final String TAG = "LovUtil";
	private static final boolean DEBUG = BuildConfig.DEBUG;

	private ILovdreamDevice mService;
	public static boolean gUseBackNode = true;

	private LovUtil(){
		mService = ILovdreamDevice.Stub.asInterface(getServiceBinder());
	}

	private static final class HOLDER {
		private static final LovUtil INSTANCE = new LovUtil();
	}

	public static LovUtil getInstance() {
		return HOLDER.INSTANCE;
	}

	private static IBinder getServiceBinder(){
		IBinder binder = null;
		try{
			Class<?> ServiceManager = Class.forName("android.os.ServiceManager");
			Method m = ServiceManager.getMethod("getService", String.class);
			binder = (IBinder)m.invoke((Object)null, "lovd_device");
		}catch(Exception e){
			e.printStackTrace();
			Log.e(TAG,"can not get system service,is System ready?");
		}
		return binder;
	}

	public void write(String path, String flag) {
		try {
			mService.writeForBackNode(path, flag);
			gUseBackNode = true;
			if (DEBUG) Log.d(TAG, "writeForBackNode(), path = " + path + ", flag = " + flag);
		} catch (NoSuchMethodError e) {
			try {
				mService.writeToFile(path, flag);
                gUseBackNode = false;
				if (DEBUG) Log.d(TAG, "writeToFile(), path = " + path + ", flag = " + flag);
			} catch (RemoteException ex) {
				ex.printStackTrace();
			}
		} catch (RemoteException e) {
			e.printStackTrace();
		}
	}

	public String read(String path) {
		String result = "";
		try {
			result = mService.readBackNode(path);
            gUseBackNode = true;
		} catch (NoSuchMethodError e) {
			try {
				result = mService.readToFile(path);
                gUseBackNode = false;
			} catch (RemoteException ex) {
				ex.printStackTrace();
			}
		} catch (RemoteException e) {
			e.printStackTrace();
		}
		if (DEBUG) Log.d(TAG, "read result(is Null? " + (null == result) + "): " + result);
		if (null == result) {
			result = "";
		}
		return result;
	}
}
