package com.unistrong.pogoservicelib.pogoservice.devices;

import com.unistrong.miscutils.SystemPropertiesUtil;

public class DeviceDefault implements DeviceStragety {
    String mDifferentDataSerialPort = "/dev/ttyHSL1";
    int mDifferentDataSerialBaudRate =  115200;
    String mPogoPowerNode = "/sys/class/ext_dev/function/power_en";
    String mPogoVbusNode = "/sys/class/ext_dev/function/ext_dev_5v_enable";
    String mPogoVbatNode = "/sys/class/ext_dev/function/ext_dev_3v3_enable";
    String mPogoRealSerialPort = "/dev/ttyHSL1";
    String mPogoGpio1Node = "/sys/class/ext_dev/function/pin10_en";
    String mPogoGpio2Node = "/sys/class/ext_dev/function/pin11_en";
    String mPogoIrqNode = "/sys/class/ext_dev/function/irq_state";

    public String getDifferentDataSerialPort() {
        return mDifferentDataSerialPort;
    }

    public int getDifferentDataSerialBaudRate() {
        return mDifferentDataSerialBaudRate;
    }

    public String getPowerNode() {
        return mPogoPowerNode;
    }

    public String getVbusNode() {
        return mPogoVbusNode;
    }

    public String getVbatNode() {
        return mPogoVbatNode;
    }

    public String getPogoRealSerialPort() {
        return mPogoRealSerialPort;
    }

    @Override
    public String getPogoVirtualSerialPort() {
        String serialPath = SystemPropertiesUtil.getProperty("persist.sys.nemapty");
        return serialPath;
    }

    public String getPogoGpio1Node() {
        return mPogoGpio1Node;
    }

    public String getPogoGpio2Node() {
        return mPogoGpio2Node;
    }

    public String getPogoIrqNode() {
        return mPogoIrqNode;
    }
}
