package com.unistrong.pogoservicelib.pogoservice.devices;

import android.os.Build;
import java.util.HashMap;
import java.util.Map;

public class DeviceFactory {
    private DeviceStragety mDevice = null;

    private static Map<String, DeviceStragety> mDeviceMap = new HashMap<>();

    static {
        mDeviceMap.put("A8", new DeviceA8());
    }

    private DeviceFactory() {
        getDevice();
    }

    public static DeviceFactory getInstance() {
        return DeviceFactoryHolder.HOLDER;
    }
    private static class DeviceFactoryHolder {
        private static final DeviceFactory HOLDER = new DeviceFactory();
    }

    public DeviceStragety getDevice() {
        mDevice = mDeviceMap.get(Build.MODEL);
        if (null == mDevice) {
            mDevice = new DeviceDefault();
        }
        return mDevice;
    }
}
