package com.unistrong.pogoservicelib.pogoservice.pin;

import android.util.Log;

import com.unistrong.pogoservicelib.BuildConfig;
import com.unistrong.pogoservicelib.pogoservice.devices.DeviceFactory;
import com.unistrong.pogoservicelib.pogoservice.status.PinStatus;
import com.unistrong.pogoservicelib.pogoservice.pin.template.PogoPinImpl;

import java.io.IOException;


public final class Gpio1 extends PogoPinImpl {
    private static final String TAG = "Gpio1";
    private static final boolean DEBUG = BuildConfig.DEBUG;

    private Gpio1() {
        pPath = DeviceFactory.getInstance().getDevice().getPogoGpio1Node();
    }

    public static Gpio1 getInstance() {
        return HOLDER.INSTANCE;
    }

    @Override
    public PinStatus getELevel() {
        PinStatus pinStatus = PinStatus.LOW;
        try {
            pinStatus = super.getELevel();
            if (DEBUG)
                Log.d(TAG, "Get gpio1 level success! Current level is " + (pinStatus == PinStatus.HIGH ? "high" : "low"));
        } catch (IOException e) {
            Log.e(TAG, "Get gpio1 level failed! " + e.getMessage());
        }
        return pinStatus;
    }

    @Override
    public void setELevel(PinStatus level) {
        try {
            super.setELevel(level);
            if (DEBUG) Log.d(TAG, "Set gpio1 level success!" + level);
        } catch (IOException e) {
            Log.e(TAG, "Set gpio1 level failed! " + e.getMessage());
        }
    }

    private static final class HOLDER {
        private static final Gpio1 INSTANCE = new Gpio1();
    }
}
