package com.unistrong.pogoservicelib.pogoservice.pin;

import android.util.Log;

import com.unistrong.pogoservicelib.BuildConfig;
import com.unistrong.pogoservicelib.pogoservice.devices.DeviceFactory;
import com.unistrong.pogoservicelib.pogoservice.status.PinStatus;
import com.unistrong.pogoservicelib.pogoservice.pin.template.PogoPinImpl;

import java.io.IOException;

public final class Gpio2 extends PogoPinImpl {
    private static final String TAG = "Gpio2";
    private static final boolean DEBUG = BuildConfig.DEBUG;

    private Gpio2() {
        pPath = DeviceFactory.getInstance().getDevice().getPogoGpio2Node();
    }

    public static Gpio2 getInstance() {
        return Gpio2.HOLDER.INSTANCE;
    }

    @Override
    public PinStatus getELevel() {
        PinStatus pinStatus = PinStatus.LOW;
        try {
            pinStatus = super.getELevel();
            if (DEBUG)
                Log.d(TAG, "Get gpio2 level success! Current level is " + (pinStatus == PinStatus.HIGH ? "high" : "low"));
        } catch (IOException e) {
            Log.e(TAG, "Get gpio2 level failed! " + e.getMessage());
        }
        return pinStatus;
    }

    @Override
    public void setELevel(PinStatus level) {
        try {
            super.setELevel(level);
            if (DEBUG) Log.d(TAG, "Set gpio2 level success!" + level);
        } catch (IOException e) {
            Log.e(TAG, "Set gpio2 level failed! " + e.getMessage());
        }
    }

    private static final class HOLDER {
        private static final Gpio2 INSTANCE = new Gpio2();
    }
}
