package com.unistrong.pogoservicelib.pogoservice.pin;

import android.util.Log;

import com.unistrong.pogoservicelib.BuildConfig;
import com.unistrong.pogoservicelib.pogoservice.devices.DeviceFactory;
import com.unistrong.pogoservicelib.pogoservice.status.PinStatus;
import com.unistrong.pogoservicelib.pogoservice.pin.template.PogoIrqImpl;

import java.io.IOException;

public final class Irq extends PogoIrqImpl {
    private static final String TAG = "Irq";
    private static final boolean DEBUG = BuildConfig.DEBUG;

    private Irq() {
        pPath = DeviceFactory.getInstance().getDevice().getPogoIrqNode();
    }

    public static Irq getInstance() {
        return HOLDER.INSTANCE;
    }

    @Override
    public PinStatus getELevel() {
        PinStatus pinStatus = PinStatus.LOW;
        try {
            pinStatus = super.getELevel();
            if (DEBUG)
                Log.d(TAG, "Get gpio2 level success! Current level is " + (pinStatus == PinStatus.HIGH ? "high" : "low"));
        } catch (IOException e) {
            Log.e(TAG, "Get gpio2 level failed! " + e.getMessage());
        }
        return pinStatus;
    }

    private static final class HOLDER {
        private static final Irq INSTANCE = new Irq();
    }
}
