package com.unistrong.pogoservicelib.pogoservice.pin;

import android.util.Log;

import com.unistrong.pogoservicelib.BuildConfig;
import com.unistrong.pogoservicelib.pogoservice.devices.DeviceFactory;
import com.unistrong.pogoservicelib.pogoservice.status.PinStatus;
import com.unistrong.pogoservicelib.pogoservice.pin.template.PogoPinImpl;

import java.io.IOException;

public final class VbatPower extends PogoPinImpl {
    private static final String TAG = "VbatPower";
    private static final boolean DEBUG = BuildConfig.DEBUG;

    private VbatPower() {
        pPath = DeviceFactory.getInstance().getDevice().getVbatNode();
    }

    public static VbatPower getInstance() {
        return HOLDER.INSTANCE;
    }

    @Override
    public PinStatus getELevel() {
        PinStatus pinStatus = PinStatus.LOW;
        try {
            pinStatus = super.getELevel();
            if (DEBUG)
                Log.d(TAG, "Get vBat level success! Current level is " + (pinStatus == PinStatus.HIGH ? "high" : "low"));
        } catch (IOException e) {
            Log.e(TAG, "Get vBat level failed! " + e.getMessage());
        }
        return pinStatus;
    }

    @Override
    public void setELevel(PinStatus level) {
        try {
            super.setELevel(level);
            if (DEBUG) Log.d(TAG, "Set vBat level success!" + level);
        } catch (IOException e) {
            Log.e(TAG, "Set vBat level failed! " + e.getMessage());
        }
    }

    private static final class HOLDER {
        private static final VbatPower INSTANCE = new VbatPower();
    }
}
