package com.unistrong.pogoservicelib.pogoservice.pin;

import android.util.Log;

import com.unistrong.pogoservicelib.BuildConfig;
import com.unistrong.pogoservicelib.pogoservice.devices.DeviceFactory;
import com.unistrong.pogoservicelib.pogoservice.status.PinStatus;
import com.unistrong.pogoservicelib.pogoservice.pin.template.PogoPinImpl;

import java.io.IOException;

public final class VbusPower extends PogoPinImpl {
    private static final String TAG = "VbusPower";
    private static final boolean DEBUG = BuildConfig.DEBUG;

    private VbusPower() {
        pPath = DeviceFactory.getInstance().getDevice().getVbusNode();
    }

    public static VbusPower getInstance() {
        return HOLDER.INSTANCE;
    }

    @Override
    public PinStatus getELevel() {
        PinStatus pinStatus = PinStatus.LOW;
        try {
            pinStatus = super.getELevel();
            if (DEBUG)
                Log.d(TAG, "Get vBus level success! Current level is " + (pinStatus == PinStatus.HIGH ? "high" : "low"));
        } catch (IOException e) {
            Log.e(TAG, "Get vBus level failed! " + e.getMessage());
        }
        return pinStatus;
    }

    @Override
    public void setELevel(PinStatus level) {
        try {
            super.setELevel(level);
            if (DEBUG) Log.d(TAG, "Set vBus level success!" + level);
        } catch (IOException e) {
            Log.e(TAG, "Set vBus level failed! " + e.getMessage());
        }
    }

    private static final class HOLDER {
        private static final VbusPower INSTANCE = new VbusPower();
    }
}
