package com.unistrong.pogoservicelib.pogoservice.pin.template;

import android.content.Context;

import com.unistrong.miscutils.FileUtil;
import com.lovdream.LovUtil;
import com.unistrong.pogoservicelib.pogoservice.status.PinStatus;

import java.io.IOException;

import static com.unistrong.pogoservicelib.pogoservice.status.PinStatus.HIGH;
import static com.unistrong.pogoservicelib.pogoservice.status.PinStatus.LOW;

abstract class AbstractPogoIrq {
    public String pPath = null;
    private FileUtil operator;

    public void init() throws NullPointerException {
        if (isInited()) {
            operator.close();
        }
        if (null == pPath) {
            throw new NullPointerException("Please init irq node file path!");
        }
        operator = new FileUtil(pPath);
    }

    public boolean isInited() {
        return (null != operator);
    }

    abstract void registerObserver(Context context, IStatusChangeCallback callback);

    abstract void unregisterObserver();

    public PinStatus getELevel() throws IOException {
        PinStatus level;
        String result = LovUtil.getInstance().read(pPath);
        //level = "1".equals(operator.readLine()) ? HIGH : LOW;
        level = (result.isEmpty() || "1".equals(result)) ? LOW : HIGH;
        return level;
    }

    public void deInit() {
        if (!isInited()) return;
        operator.close();
        operator = null;
    }
}
