package com.unistrong.pogoservicelib.pogoservice.pin.template;

import com.unistrong.miscutils.FileUtil;
import com.lovdream.LovUtil;
import com.unistrong.pogoservicelib.pogoservice.status.PinStatus;

import java.io.IOException;

import static com.unistrong.pogoservicelib.pogoservice.status.PinStatus.HIGH;
import static com.unistrong.pogoservicelib.pogoservice.status.PinStatus.LOW;

abstract class AbstractPogoPin {

    public String pPath = null;
    private FileUtil operator;

    public void init() throws NullPointerException {
        if (isInited()) {
            operator.close();
        }
        if (null == pPath) {
            throw new NullPointerException("Please init gpio node file path!");
        }
        operator = new FileUtil(pPath);
    }

    public boolean isInited() {
        return (null != operator);
    }

    public PinStatus getELevel() throws IOException {
        PinStatus level = LOW;
        //level = "1".equals(operator.readLine()) ? HIGH : LOW;
        level = "1".equals(LovUtil.getInstance().read(pPath)) ? HIGH : LOW;
        return level;
    }

    public void setELevel(PinStatus level) throws IOException {
        //operator.write(level);
        LovUtil.getInstance().write(pPath, level == HIGH ? "1" : "0");
    }

    public void deInit() {
        if (!isInited()) return;
        operator.close();
        operator = null;
    }
}
