package com.unistrong.pogoservicelib.pogoservice.pin.template;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.util.Log;


import com.unistrong.pogoservicelib.BuildConfig;

import java.io.IOException;

public class PogoIrqImpl extends AbstractPogoIrq {
    private static final String TAG = "PogoIrqImpl";
    private static final boolean DEBUG = BuildConfig.DEBUG;

    private static final String sPogoInterruptAction = "android.intent.action.ext_pogo_interrupt";

    private IStatusChangeCallback mStatusChangeCallback;
    private IntentFilter mIrqFilter = new IntentFilter(sPogoInterruptAction);
    private IrqBroadcast mIrqBroadcast = new IrqBroadcast();
    private Context mContext;

    @Override
    public void registerObserver(Context context, IStatusChangeCallback callback) {
        mContext = context;
        mStatusChangeCallback = callback;
        context.registerReceiver(mIrqBroadcast, mIrqFilter);
    }

    @Override
    public void unregisterObserver() {
        mContext.unregisterReceiver(mIrqBroadcast);
        mStatusChangeCallback = null;
        mContext = null;
    }

    private class IrqBroadcast extends BroadcastReceiver {
        @Override
        public void onReceive(Context context, Intent intent) {
            try {
                mStatusChangeCallback.onIrqStatusChange(getELevel());
            } catch (IOException e) {
                // ignore
                Log.e(TAG, "Get irq level status failed! " + e.getMessage());
            }
        }
    }
}
