package com.unistrong.pogoservicelib.pogoservice.serial.template;

import android.util.Log;

public class SoManager {

    private static int fd_ttyHSL1 = -1;


    //7165 end
    static {
        System.loadLibrary("so_manager");
    }


    private static native int jniOpenDev(String path, int baudrate, int bits,
                                         int event, int stop);

    private static native int jniCloseDev(int fdevice);

    private static native int jniRead(byte[] readBuffer, int lenght, int fdevice);

    private static native int jniMinRead(byte[] readBuffer, int lenght,
                                         int fdevice);

    private static native int jniWrite(byte[] buffer, int lenght, int fdevice);

//	private static native int init(int onOff);

    private static native int laGaoOrLadi(String path, int onOff);


    public static boolean openDevice(String path, int baudrate, int bits, int event, int stop) {
        Log.d("", "---path=" + path);
        fd_ttyHSL1 = jniOpenDev(path, baudrate,
                bits, event, stop);
        return fd_ttyHSL1 > 0;
    }

    public static int readPin12(byte[] data) {
        return readMinData(data);
    }

    public static void laGao(String path) {
        laGaoOrLadi(path, 1);
    }

    public static void laDi(String path) {
        laGaoOrLadi(path, 0);
    }


    public static int readMinData(byte[] data) {
        int len = -1;
        if (fd_ttyHSL1 > 0) {
            len = jniMinRead(data, data.length, fd_ttyHSL1);
        }
        return len;
    }

    public static int readData(byte[] data) {
        int len = -1;
        if (fd_ttyHSL1 > 0) {
            len = jniRead(data, data.length, fd_ttyHSL1);
        }
        return len;
    }

    public static void sendData(byte[] data) {
        int len = 0;
        if (fd_ttyHSL1 > 0) {
            len = jniWrite(data, data.length, fd_ttyHSL1);
        }
        Log.d("", "jniWrite length = " + len);
    }

    public static void closeDevice() {
        jniCloseDev(fd_ttyHSL1);
    }

}
