package com.unistrong.pogoservicelib.pogoservice.service;

import android.app.ActivityManager;
import android.app.Service;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.os.IBinder;
import android.util.Log;

import com.unistrong.pogoservicelib.BuildConfig;

import java.util.List;
import java.util.Timer;
import java.util.TimerTask;

public class GuardService extends Service {
    public static final String ACTION_GUARD_SERVICE_NEED_REBOOT = "guard_service_need_reboot";
    private static final String TAG = "GuardService";
    private static final boolean DEBUG = BuildConfig.DEBUG;
    Thread thread = new Thread(new Runnable() {

        @Override
        public void run() {
            Timer timer = new Timer();
            TimerTask task = new TimerTask() {

                @Override
                public void run() {
                    boolean b = isServiceWork(GuardService.this, PogoService.class.getName());
                    if (DEBUG) Log.d(TAG, "Pogo service is" + (b ? " " : " not ") + "running");
                    if (!b) {
                        Intent intent = new Intent("services.PogoService");
                        ComponentName componentName = new ComponentName(getPackageName(), PogoService.class.getName());
                        intent.setComponent(componentName);
                        //GuardService.this.startService(intent);
                    }
                }
            };
            timer.schedule(task, 0, 2 * 1000);
        }
    });

    @Override
    public int onStartCommand(Intent intent, int flags, int startId) {
        thread.start();
        return START_STICKY;
    }

    @Override
    public IBinder onBind(Intent intent) {
        return null;
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        if (null != thread) {
            thread.interrupt();
            thread = null;
        }
    }

    /**
     * 判断某个服务是否正在运行的方法
     *
     * @param mContext
     * @param serviceName 是包名+服务的类名（例如：net.loonggg.testbackstage.TestService）
     * @return true代表正在运行，false代表服务没有正在运行
     */
    public boolean isServiceWork(Context mContext, String serviceName) {
        boolean isWork = false;
        ActivityManager myAM = (ActivityManager) mContext
                .getSystemService(Context.ACTIVITY_SERVICE);
        List<ActivityManager.RunningServiceInfo> myList = myAM.getRunningServices(40);
        if (myList.size() <= 0) {
            return false;
        }
        for (int i = 0; i < myList.size(); i++) {
            String mName = myList.get(i).service.getClassName();
            if (mName.equals(serviceName)) {
                isWork = true;
                break;
            }
        }
        return isWork;
    }
}
